
#version 330 core

uniform sampler2D real_texture;
uniform sampler2D white_texture;
uniform vec2 light_position;
uniform vec2 screen_dimension;
uniform float decay;
uniform float density;
uniform float exposure;

in  vec2 ex_coord;
out vec4 out_color;

void main(void)
{
	vec2 deltaTextCoord = ex_coord - light_position;
 	vec2 textCoo = ex_coord;
 	deltaTextCoord *= 1.0  /  100.0 * density;
 	float illuminationDecay = 1.0;

	vec4 total = vec4(0.0,0.0,0.0,0.0);

 	for(int i=0; i < 100 ; i++)

  	{

    			textCoo -= deltaTextCoord;

    			vec4 sample = texture2D(white_texture, textCoo );

    			
    			sample *= illuminationDecay * decay;

    			
    			total += sample;

    			
    			illuminationDecay *= decay;

 	}

	total *= (0.5 + 0.5 * fract(sin(dot(decay * ex_coord, vec2(12.9898, 78.233)))* 43758.5453))*0.6 + 1.0;
 	total *= exposure;
	out_color = texture(real_texture,ex_coord) + total;
}